#!/usr/bin/python

# Pyle, a WikiClone in Python
# Copyright (C) 1999, 2000 Tony Garnock-Jones <tonyg@kcbbs.gen.nz>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import sys
import shelve
import string
import os
import re
import cgi

from Utils import *
from Actions import *
import Users
import Config

Users.process_auth(getarg('loginname'), getarg('loginpass'))

mode = getarg('mode', 'read')
arg = getarg('arg', '')
data = getarg('data')

auth_reqd = 0
if mode in ['edit', 'save', 'del', 'attach', 'updattach', 'newattach', 'delattach']:
	auth_reqd = not Config.allow_anonymous_edit
elif mode in ['read', 'getattach', 'history']:
	auth_reqd = not Config.allow_anonymous_view
elif mode in ['subscribe', 'unsubscribe']:
	auth_reqd = 1

if auth_reqd:
	Users.ensure_auth()

if mode == 'read':
	if arg == '':
		arg = frontpage
	readpage(arg, None, data)
elif mode == 'edit': editpage(arg, data)
elif mode == 'find': searchform(arg)
elif mode == 'search': searchpage(arg)
elif mode == 'backlinks': backlinks(arg)
elif mode == 'save': savepage(arg, data, getarg('convertspaces', ''))
elif mode == 'del': delpage(arg)
elif mode == 'attach': attachpage(arg)
elif mode == 'updattach': updattachpage(arg, data,
				getarg('mimetype', 'application/octet-stream'),
				getarg('content'),
				getarg('inline', ''),
				getarg('extraattrs', ''))
elif mode == 'getattach': getattachpage(arg, data)
elif mode == 'newattach': newattachpage(arg, data,
				getarg('mimetype', 'application/octet-stream'),
				getarg('content'),
				getarg('inline', ''),
				getarg('extraattrs', ''))
elif mode == 'delattach': delattachpage(arg, data)
elif mode == 'rights': rightspage(arg)
elif mode == 'subscribe': subscribepage(arg)
elif mode == 'unsubscribe': unsubscribepage(arg)
elif use_cvs and mode == 'history': historypage(arg)
else:
	die_with_message("Unknown mode '" + mode + "'.")
