import Utils
import Config
import string
import re
import cgi

inlinere = re.compile(Config.inlinepattern)

def SpanHandler(rest, renderer, acc):
    (text, rest) = renderer.collectSpan(rest)

    parts = string.split(text, '/', 1)
    name = parts[0]
    pagename = ''

    if name.find(':') != -1:
        (pagename, name) = string.split(name, ':', 1)
    if pagename:
        attachments = Utils.dbget(pagename, 'attachments', {})
    else:
        pagename = renderer.pagename
        attachments = renderer.attachments

    if len(parts) > 1:
        alt = parts[1]
    else:
        alt = '[Attachment ' + pagename + ':' + name + ']'

    if attachments.has_key(name):
        a = attachments[name]
        if a.inlinecontent:
            if inlinere.search(a.mimetype):
                if Utils.static_mode():
                    result = '<img src="' + pagename + '_getattach_' + \
                             name + Utils.mimetype_extension(a.mimetype)
                else:
                    result = '<img src="' + Utils.scriptname + '?mode=getattach&arg=' + \
                             pagename + '&data=' + name
                acc.append(result + '" alt="' + alt + '" ' + a.getattrs() + '>')
            else:
                acc.append(a.get_content())
        else:
            acc.append(Utils.internal_link(pagename, 'getattach', alt, name))
    else:
        acc.append(cgi.escape('[Missing attachment ' + pagename + ':' + name + ']'))

    return rest
